<template>
<div id="myChartMutiPie">
</div>
</template>
<script>
export default {
  name:'mutPie',
  props:{
    cameraList:{
      type:Array,
      default:()=>{
        //[离线，在线]
        return [98,324]
      }
    },
    visitorList:{
      type:Array,
      default:()=>{
        return [4,12]
      }
    },
    analysis:{
      type:Array,
      default:()=>{
        return [7,23]
      }
    }
  },
  watch: {
    cameraList: {
      handler:function(val,oldVal){
        if(val !== oldVal){
          this.init()
        }
      },
      deep:true
    },
    visitorList: {
      handler:function(val,oldVal){
        if(val !== oldVal){
          this.init()
        }
      },
      deep:true
    },
    analysis: {
      handler:function(val,oldVal){
        if(val !== oldVal){
          this.init()
        }
      },
      deep:true
    },
    "TreeDataPool.showTreeBox":{
      handler:function(val,oldVal){
        if(val !== oldVal){
          this.handleResize()
        }
      }
    },
  },
  data() {
    return {
      myChart:Object
    }
  },
  computed: {
    options(){
      return {
        title: {
          
        },
        legend: {
          x:"left",
          textStyle:{
            color:"#ffffff"
          }
        },
        tooltip: {
          trigger: "item",
          formatter: function (params, ticket, callback) {
            return params.name + "：" + params.value[params.seriesIndex + 1] + "占比：" + params.percent + "%"
          }
        },
        dataset: {
            source: [
                ['product', '摄像机', '访客机', '视频分析'],
                ['离线', this.cameraList[0], this.visitorList[0], this.analysis[0]],
                ['在线', this.cameraList[1], this.visitorList[1], this.analysis[1]]
            ]
        },
        series: [
          {
            type: 'pie',
            height: "100%",
            radius: 40,
            center: ['20%', '50%'],
            encode: {
                itemName: 'product',
                value: '摄像机'
            },
            itemStyle: {
              color: (parrams)=>{
                let colorList = [
                  '#c59b3a','#0a81fd', '#FFFF00', '#FF8C00', '#FF0000', '#FE8463'
                ]
                return colorList[parrams.dataIndex]
              }
            },
            label:{
              show:true,
              position:"inside",
              formatter: (params)=>{
                return params.value[params.seriesIndex + 1]
              }
            },
            labelLine:{
              show:false
            }
          }, {
            type: 'pie',
            radius: 40,
            center: ['51.3%', '50%'],
            encode: {
                itemName: 'product',
                value: '访客机'
            },
            labelLine:{
              show:false
            },
            label:{
              show:true,
              position:"inside",
              formatter: (params)=>{
                return params.value[params.seriesIndex + 1]
              }
            },
            itemStyle: {
              color: (parrams)=>{
                let colorList = [
                  '#c59b3a','#0a81fd', '#FFFF00', '#FF8C00', '#FF0000', '#FE8463'
                ]
                return colorList[parrams.dataIndex]
              }
            }
          }, {
            type: 'pie',
            radius: 40,
            center: ['82.6%', '50%'],
            encode: {
                itemName: 'product',
                value: '视频分析'
            },
            labelLine:{
              show:false
            },
            label:{
              show:true,
              position:"inside",
              formatter: (params)=>{
                return params.value[params.seriesIndex + 1]
              }
            },
            itemStyle: {
              color: (parrams)=>{
                let colorList = [
                  '#c59b3a','#0a81fd', '#FFFF00', '#FF8C00', '#FF0000', '#FE8463'
                ]
                return colorList[parrams.dataIndex]
              }
            }
          }
        ]
      }
    }
  },
  methods: {
    init(){
      this.myChart.setOption(this.options)
    },
    handleResize(){
      this.myChart.resize()
    }
  },
  mounted() {
    this.myChart = this.$echarts.init(document.getElementById('myChartMutiPie'));
    this.myChart.setOption(this.options);
    this.myChart.resize();
  },
  created() {
    
  },
  destroyed() {
    
  }
}
</script>
<style lang="scss">
#myChartMutiPie{
  width: 100%;
  height: 100%;
}
</style>
